using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;

namespace CallCenterApi.DAL
{

    /// <summary>
    /// 数据访问类:submit_case_finish_info
    /// </summary>
    public partial class submit_case_finish_info
    {
        public submit_case_finish_info()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "submit_case_finish_info");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from submit_case_finish_info");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.submit_case_finish_info model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into submit_case_finish_info(");
            strSql.Append("CASE_SERIAL,AREA_CODE,FINISH_TYPE,DEPT_NAME,DEPT_CODE,FINISH_TIME,FINISH_NAME,FINISH_CONTENT,END_TIME,END_LENGTH,CreateTime,FINISH_STATUS)");
            strSql.Append(" values (");
            strSql.Append("@CASE_SERIAL,@AREA_CODE,@FINISH_TYPE,@DEPT_NAME,@DEPT_CODE,@FINISH_TIME,@FINISH_NAME,@FINISH_CONTENT,@END_TIME,@END_LENGTH,@CreateTime,@FINISH_STATUS)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_TYPE", SqlDbType.NVarChar,50),
                    new SqlParameter("@DEPT_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@DEPT_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_TIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_CONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@END_TIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@END_LENGTH", SqlDbType.Int,4),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@FINISH_STATUS", SqlDbType.NVarChar,50)
                    
            };
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.FINISH_TYPE;
            parameters[3].Value = model.DEPT_NAME;
            parameters[4].Value = model.DEPT_CODE;
            parameters[5].Value = model.FINISH_TIME;
            parameters[6].Value = model.FINISH_NAME;
            parameters[7].Value = model.FINISH_CONTENT;
            parameters[8].Value = model.END_TIME;
            parameters[9].Value = model.END_LENGTH;
            parameters[10].Value = model.CreateTime;
            parameters[11].Value = model.FINISH_STATUS;
            
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.submit_case_finish_info model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update submit_case_finish_info set ");
            strSql.Append("CASE_SERIAL=@CASE_SERIAL,");
            strSql.Append("AREA_CODE=@AREA_CODE,");
            strSql.Append("FINISH_TYPE=@FINISH_TYPE,");
            strSql.Append("DEPT_NAME=@DEPT_NAME,");
            strSql.Append("DEPT_CODE=@DEPT_CODE,");
            strSql.Append("FINISH_TIME=@FINISH_TIME,");
            strSql.Append("FINISH_NAME=@FINISH_NAME,");
            strSql.Append("FINISH_CONTENT=@FINISH_CONTENT,");
            strSql.Append("END_TIME=@END_TIME,");
            strSql.Append("END_LENGTH=@END_LENGTH,");
            strSql.Append("CreateTime=@CreateTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_TYPE", SqlDbType.NVarChar,50),
                    new SqlParameter("@DEPT_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@DEPT_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_TIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_NAME", SqlDbType.NVarChar,50),
                    new SqlParameter("@FINISH_CONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@END_TIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@END_LENGTH", SqlDbType.Int,4),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.FINISH_TYPE;
            parameters[3].Value = model.DEPT_NAME;
            parameters[4].Value = model.DEPT_CODE;
            parameters[5].Value = model.FINISH_TIME;
            parameters[6].Value = model.FINISH_NAME;
            parameters[7].Value = model.FINISH_CONTENT;
            parameters[8].Value = model.END_TIME;
            parameters[9].Value = model.END_LENGTH;
            parameters[10].Value = model.CreateTime;
            parameters[11].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_case_finish_info ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_case_finish_info ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_case_finish_info GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,CASE_SERIAL,FINISH_STATUS,AREA_CODE,FINISH_TYPE,DEPT_NAME,DEPT_CODE,FINISH_TIME,FINISH_NAME,FINISH_CONTENT,END_TIME,END_LENGTH,CreateTime from submit_case_finish_info ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.submit_case_finish_info model = new CallCenterApi.Model.submit_case_finish_info();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_case_finish_info DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.submit_case_finish_info model = new CallCenterApi.Model.submit_case_finish_info();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["CASE_SERIAL"] != null)
                {
                    model.CASE_SERIAL = row["CASE_SERIAL"].ToString();
                }
                if (row["AREA_CODE"] != null)
                {
                    model.AREA_CODE = row["AREA_CODE"].ToString();
                }
                if (row["FINISH_TYPE"] != null)
                {
                    model.FINISH_TYPE = row["FINISH_TYPE"].ToString();
                }
                if (row["DEPT_NAME"] != null)
                {
                    model.DEPT_NAME = row["DEPT_NAME"].ToString();
                }
                if (row["DEPT_CODE"] != null)
                {
                    model.DEPT_CODE = row["DEPT_CODE"].ToString();
                }
                if (row["FINISH_TIME"] != null)
                {
                    model.FINISH_TIME = row["FINISH_TIME"].ToString();
                }
                if (row["FINISH_NAME"] != null)
                {
                    model.FINISH_NAME = row["FINISH_NAME"].ToString();
                }
                if (row["FINISH_CONTENT"] != null)
                {
                    model.FINISH_CONTENT = row["FINISH_CONTENT"].ToString();
                }
                if (row["END_TIME"] != null)
                {
                    model.END_TIME = row["END_TIME"].ToString();
                }
                if (row["END_LENGTH"] != null && row["END_LENGTH"].ToString() != "")
                {
                    model.END_LENGTH = int.Parse(row["END_LENGTH"].ToString());
                }
                if (row["CreateTime"] != null && row["CreateTime"].ToString() != "")
                {
                    model.CreateTime = DateTime.Parse(row["CreateTime"].ToString());
                }
                if (row["FINISH_STATUS"] != null)
                {
                    model.FINISH_STATUS = row["FINISH_STATUS"].ToString();
                }
                
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,FINISH_STATUS,CASE_SERIAL,AREA_CODE,FINISH_TYPE,DEPT_NAME,DEPT_CODE,FINISH_TIME,FINISH_NAME,FINISH_CONTENT,END_TIME,END_LENGTH,CreateTime ");
            strSql.Append(" FROM submit_case_finish_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,CASE_SERIAL,FINISH_STATUS,AREA_CODE,FINISH_TYPE,DEPT_NAME,DEPT_CODE,FINISH_TIME,FINISH_NAME,FINISH_CONTENT,END_TIME,END_LENGTH,CreateTime ");
            strSql.Append(" FROM submit_case_finish_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM submit_case_finish_info ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from submit_case_finish_info T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "submit_case_finish_info";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}